import os
from os import path
import subprocess
import sys

total = len(sys.argv)
script_name = str(sys.argv[0])
if total != 2:
   print ('Script usage: python ', script_name, ' db-schema-list_filename')
   exit ()
str(sys.argv[1])
#print(str(sys.argv[1]))

path = os.getcwd()
#print(path)

code_dir = ''
stage_cmd_schema = ''
sct_jar_file = ''
batch_xml = ""

schemalist = open(str(sys.argv[1]),"r")

for aline in schemalist.readlines():
    li = aline.strip()
    if not li.startswith("#"):
        values = li.split(',')

        s_vendor = values[0]
        s_host = values[1]
        s_dbname = values[2]
        s_user = values[3]
        s_pwd = values[4]
        s_schema = values[5]
        s_port = values[6]
        s_sid = values[7]

        t_vendor = values[8]
        t_host = values[9]
        t_user = values[10]
        t_pwd = values[11]
        t_dbname = values[12]
        t_port = values[13]

        code_dir = path
        stage_cmd_schema = s_schema.lower()
        sct_jar_file = "AWSSchemaConversionToolBatch.jar"
        #print code_dir
        #print sct_jar_file
        batch_xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?> \n" + \
                    "<tree> \n" + \
                    "  <instances> \n" + \
                    "    <BatchJob> \n" + \
                    "      <NewProjectCommand targetVendor=\"" + t_vendor + "\" projectName=\"" + s_vendor + "-" + s_schema + "-to-" + t_vendor + "\" directory=\"" + code_dir + "/projects/\" sourceVendor=\"" + s_vendor + "\"></NewProjectCommand> \n" + \
                    "      <ConnectCommand vendor=\"" + s_vendor + "\" origin=\"SOURCE\" password=\"" + s_pwd + "\" userName=\"" + s_user + "\" encryptConnection=\"false\" trustServerConnection=\"false\" requireSsl=\"false\" verifyServerCertificat=\"false\" tlsAuthentication=\"false\" serverName=\"" + s_host + "\" serverPort=\"" + s_port + "\" sid=\"" + s_sid + "\" connectionType=\"BASIC_SID\" keyStoreAlias=\"\" trustStoreAlias=\"\" processMode=\"MAIN\" recursionDepth=\"1\"></ConnectCommand> \n" + \
                    "      <ConnectCommand vendor=\"" + t_vendor + "\" origin=\"TARGET\" password=\"" + t_pwd + "\" userName=\"" + t_user + "\" encryptConnection=\"false\" trustServerConnection=\"false\" requireSsl=\"false\" verifyServerCertificat=\"false\" tlsAuthentication=\"false\" serverName=\"" + t_host + "\" serverPort=\"" + t_port + "\" sid=\"" + t_dbname + "\" connectionType=\"BASIC_SID\" keyStoreAlias=\"\" trustStoreAlias=\"\" processMode=\"MAIN\" recursionDepth=\"1\"></ConnectCommand> \n" + \
                    "       <LoadScriptCommand directory=\"" + code_dir + "/input\" /> " + \
                    "       <ConvertScriptCommand script=\"" + code_dir + "/input\" /> " + \
                    "       <SaveScriptCommand script=\"" + code_dir + "/input\" rewrite=\"true\" directory=\"" + code_dir + "/output\" /> " + \
                    "      <SaveProjectCommand></SaveProjectCommand> \n" + \
                    "    </BatchJob> \n" + \
                    "  </instances> \n </tree> \n"

        #print batch_xml

        if not os.path.exists(code_dir + '/projects'):
            os.makedirs(code_dir + '/projects')
        xmlFile = code_dir + "/projects/" + s_vendor + "-" + s_schema + "-to-" + t_vendor + "-sql.xml"
        print('SQL Script XML file generated on -> ' + xmlFile)
        file = open(xmlFile, "w")
        file.write(batch_xml)
        file.close()

        print('SQL Script Code conversion starts for schema -> ' + s_schema)
        #print('sct_jar_file --> ' + sct_jar_file)

        if t_vendor.lower() == 'postgresql':
            subprocess.call(['java', '-d64', '-Xmx10240m', '-Xms2048m', '-cp', sct_jar_file, 'com.amazon.sct.batch.BatchExecutor', 'execute', xmlFile])
        else:
            subprocess.call(['java', '-d64', '-Xmx10240m', '-Xms2048m', '-cp', sct_jar_file, 'com.amazon.sct.batch.BatchExecutor', 'execute', xmlFile])

        print('SQL Script Code conversion completed for schema -> ' + s_schema)
